<template>
    <div class="row justify-start item-center q-mt-md-lg col-12 no-scroll">
        <div class="col-md-4 col-12 q-ml-md-md font-18 text-black q-mt-xs">
            <q-btn
                class="q-pa-none"
                flat
                no-caps
                @click="selectCurrentPage('default')"
            >
                <q-icon name="arrow_back" color="black" size="25px" />
                <span class="font-18 helvetica-neue-medium q-pl-md">
                    {{ $t('client.createClient') }}
                </span>
            </q-btn>
        </div>
        <div class="col-md-7 items-center">
            <q-btn
                no-caps
                text-color="white"
                class="
                    button-save
                    desktop-save
                    float-right
                    helvetica-neue-medium
                "
                @click="createCustomer"
                :label="$t('button.save')"
            />
        </div>
    </div>
    <div class="row justify-start item-center q-mt-md-lg col-12">
        <div class="col-12 col-md-4 items-center q-ma-md-md q-pl-md-lg">
            <div class="col-md-3 col-12 q-mt-xs items-center q-mr-md-md">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('client.clientName') }}
                    <span class="text-ff0000 font-10" v-if="!state.clientName">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    dense
                    v-model="state.clientName"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>
            <div class="col-md-3 col-12 q-mt-xs items-center q-mr-md-md">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('client.hp') }}
                    <span class="text-ff0000 font-10" v-if="!state.hp">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    dense
                    type="tel"
                    v-model="state.hp"
                    bg-color="blue-2"
                    class="border-radius-20"
                    hint="Format: +6012345678"
                ></q-input>
            </div>
        </div>
        <div class="col-12 col-md-4 items-center q-ma-md-md q-pl-md-lg">
            <div class="col-md-3 col-12 q-mt-xs items-start q-mr-md-md">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('client.note') }}
                </p>
                <q-input
                    outlined
                    dense
                    type="textarea"
                    v-model="state.note"
                    autogrow
                    bg-color="blue-2"
                    class="border-radius-20 text-business"
                ></q-input>
            </div>
        </div>
    </div>
    <div class="col-12 col-md-3 col-lg-3 q-mt-xs-md items-center">
        <q-btn
            no-caps
            text-color="white"
            class="col-10 button-save mobile-save w-100 helvetica-neue-medium"
            :label="$t('button.save')"
            @click="createCustomer"
        />
    </div>
</template>
<script lang="ts">
import { useStore } from 'src/store';
import { defineComponent, ref, reactive } from 'vue';

export default defineComponent({
    name: 'CreateCustomer',
    setup(props, { emit }) {
        let state = reactive({
            clientName: '' as any,
            hp: '' as any,
            note: '' as any,
            userId: '' as any
        });
        const store = useStore();

        const selectCurrentPage = (page: any) => {
            emit('update-customer', page);
        };

        const createCustomer = async () => {
            let body = {
                name: state.clientName,
                phone: state.hp
            };
            const result: any = await store.dispatch(
                'business/createCustomer',
                body
            );

            if (result) {
                if (state.note) {
                    let noteBody = {
                        note: state.note,
                        userId: result.customer.id
                    };

                    await store.dispatch('business/putNote', noteBody);
                }
                selectCurrentPage('default');
            }
        };

        const reset = () => {
            state.clientName = '';
            state.hp = '';
            state.note = '';
            state.userId = '';
        };

        store.watch(
            (state) => state.business.businessID,
            () => {
                reset();
            }
        );

        return {
            state,
            store,
            selectCurrentPage,
            dense: ref(true),
            createCustomer
        };
    }
});
</script>
